#!/usr/bin/perl -w

################################################################################
#
# This perl script will look at the galleries DBs and image server to check that
# the uncropped and cropped tif files are up to date.
#                      
#  Copyright (c) 2010 Joseph Padfield <joseph.padfield@ng-london.org.uk>
#
#  ---------------------------------------------------------------------------
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#   ---------------------------------------------------------------------------
#
#	This script has been developed in Version 8.10 of Unbuntu Linux 
#
#	In addition to perl you will also need to install the following packages:
#
#  # 
#
#	Plus any additional packages that these three rely on.
#		
################################################################################

use DBI;   
use POSIX qw(ceil floor sqrt);
use File::Basename;

my $dirname = dirname(__FILE__);
require( $dirname."/header.pl" );

my $img = $ARGV[0];
my $pyr = $ARGV[1];
my $process = $ARGV[2];
my @suffixlist = (".jpg", ".JPG", ".tif", ".TIF", ".pdf", ".doc", "");
my $debug;
my $output;

my ($name,$path,$suffix) = fileparse("$img",@suffixlist);
my $us = uc($suffix);
my $ufs = ucfirst($suffix);
my $buim = $data_folder."/project_edited/$name$suffix";
  
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime();
  $year += 1900;
  $mon = sprintf("%02.0f", $mon + 1);
  $mday = sprintf("%02.0f", $mday);
    
my $targetpath = $data_folder."/project_edited/$year/$mon/$mday";
my $tm = time();
my $tmp = $data_folder."/project_edited/$year/$mon/$mday/$name"."_".$tm.$suffix;
my $logfile = $data_folder."/project_edited/log/edit_log_$year"."_$mon"."_$mday".".log";
my $logtxt = "$year-$mon-$mday\tProcess:$process\tImage:$name$suffix\tBackup:$tmp\n";
my $mkp = "mkdir -p \"$targetpath\"";  

unless (-d "$targetpath")
  {$debug = `$mkp`;
   if (-d "$targetpath") {`chmod -R a+rw \"$targetpath\"`;}
  if ($debug) {$output .= $debug."\n"}}

if (-e "$img")
  {$output .= "Input image ok, continue:<br>\n";
   $cmdM = "not needed";}
else
  {
  $output .= "PROBLEM with input image, checking suffix:<br>\n";
  #Make file suffix lower case .
  if (-e "$path$name$us")
    {$cmdM = "mv \"$path$name$us\" \"$img\"";}
  elsif (-e "$path$name$ufs")
    {$cmdM = "mv \"$path$name$us\" \"$img\"";}
  else
    {$cmdM = "";
     $output .= "FILE NOT FOUND:<br>\n"}
    
  if ($cmdM)
    {$debug = `$cmdM`;
  if ($debug) {$output .= $debug."\n"}}
  else
    {print "NOT FOUND, $us: $ufs<br>\n";}
  }
  
if (!$process)
  {$process = 0;}

$cmd1 = "cp \"$img\" \"$tmp\"";
  
if ($process eq "flip")
  {$cmd2 = "$vips im_fliphor \"$tmp\" \"$img\"";}
elsif ($process eq "r90")
  {$cmd2 ="$vips im_rot90 \"$tmp\" \"$img\"";}
elsif ($process eq "r180")
  {$cmd2 ="$vips im_rot180 \"$tmp\" \"$img\"";}
elsif ($process eq "r270")
  {$cmd2 ="$vips im_rot270 \"$tmp\" \"$img\"";}
else
  {$cmd2 = "$vips im_copy \"$tmp\" \"$img\"";}
  
$cmd3 = "rm \"$pyr\"";
$cmd4 = "./makePyr.sh \"$img\" \"$pyr\"";
#$cmd5 = "rm $tmp";

$output .= "MKP: $mkp<br>";
$output .= "CM: $cmdM<br>";
$output .= "C1: $cmd1<br>";
$output .= "C2: $cmd2<br>";
$output .= "C3: $cmd3<br>";
$output .= "C4: $cmd4<br>";

if ($cmd2)
  {
  $debug = `$cmd1`;
  if ($debug) {$output .= $debug."\n"}
  
  $debug = `$cmd2`;
  if ($debug) {$output .= $debug."\n"}
    
  if (-e "$pyr") 
    {$debug = `$cmd3`; 
     if ($debug) {$output .= $debug."\n"}}
     
  $debug = `$cmd4`;
  if ($debug) {$output .= $debug."\n"}
     
   if ($logfile)
    {open (MYFILE, '>>'.$logfile);
    print MYFILE $logtxt;
    close (MYFILE);}
  }
  
if (-e "$pyr") {$output .= "New pyramid produced\n";}
else {$output .= "Failed to produce new pyramid\n";}

#print $output;
  
